/*---------------------------------------------------------------------------*
  Project:  sndio
  File:     sndio_Api.h

  Copyright (C)2010 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Rev: 20875 $
 *---------------------------------------------------------------------------*/

#ifndef SNDIO_API_H
#define SNDIO_API_H


#include <wchar.h>
#include <nn/types.h>
#include <nn/fs.h>
#include <nn/dbg.h>
#include "detail/sndio_Result.h"
#include "detail/sndio_VoiceTypes.h"


/*!
    @brief      TEhIO֘A`
*/
namespace sndio {

    /*!
        @brief      ܂B

                    }Eg͓ōs܂B<br/>

        @retval     ResultSuccess               
        @retval     ResultMediaNotFound         fBAĂȂ
        @retval     ResultMediaInvalid          fBAs
        @retval     ResultNotFormatted          tH[}bg
        @retval     ResultBadFormat             stH[}bg
        @retval     ResultArchiveInvalidated    A[JCus
        @retval     ResultMediaAccessError      ANZXG[
        @retval     ResultOperationDenied       ANZX
        @retval     ResultError                 sȃG[
    */
    Result Initialize();

    /*!
        @brief      SDJ[hɂ鉹̍č\z܂B

                    }Egɍs܂B

        @retval     ResultSuccess               
        @retval     ResultMediaNotFound         fBAĂȂ
        @retval     ResultMediaInvalid          fBAs
        @retval     ResultNotFormatted          tH[}bg
        @retval     ResultBadFormat             stH[}bg
        @retval     ResultArchiveInvalidated    A[JCus
        @retval     ResultMediaAccessError      ANZXG[
        @retval     ResultOperationDenied       ANZX
        @retval     ResultError                 sȃG[
    */
    Result Restore();

    /*!
        @brief      j܂B

                    AvP[VNxĂяo\łB<br />
                    @ref Finalize ĂяoȌ @ref Initialize ł܂B<br />
                    SDJ[h̍ă}EgKvȏꍇ @ref Restore gpB
    */
    void Finalize();

    /*!
        @brief      SDJ[hɂ鉹̍č\z܂B

                    SDJ[h}EgĂȂ΍č\z͍s܂B

        @return     č\zɊȂ true 
                    łȂ false Ԃ܂B
    */
    bool IsInitialized();

    /*!
        @brief      y[WsȏԂǂԂ܂

        @retval     true    y[Ws(fBNg)Ԃł
        @retval     false   y[Wł
    */
    bool IsInvalidPage( VoicePage page );

    /*!
        @brief      w肳ꂽʒuɉ݂邩Ԃ܂B

                    CfbNXɂ̓y[Wɑ݂鉹CfbNXԍw肵܂B<br />
                    wCfbNXɎwł͈͂[0-17]ɂȂ܂B<br />

        @param[in]  page        wy[Wԍ
        @param[in]  index       wCfbNX([0-17])

        @return     trueȂ特݂܂BfalseȂ特݂܂B
    */
    bool IsExistsEntry( VoicePage page, s32 index );

    /*!
        @brief      o^Ă鉹̃Gg擾܂B

                    wCfbNXɎwł͈͂[0-17]ɂȂ܂B<br/>
                    wy[WAwCfbNXɃf[^ꍇfalseԂ܂<br/>

        @param[out] pOut        Gg
        @param[in]  page        wy[W
        @param[in]  index       wCfbNX

        @return     trueœǂݍ݂BfalseœǂݍݎsB
    */
    bool ReadEntry( VoiceEntry* pOut, VoicePage page, s32 index );

    /*!
        @brief      ۑΏۂ̉̃Gg쐬܂

                    󂢂Ă鉹ӏɑ΂ĉۑ邽߂̃pX쐬AGgƂĕԂ܂B<br/>
                    wCfbNXɎwł͈͂[0-17]ɂȂ܂B<br/>
                    wy[WAwCfbNXɊɉ݂ꍇ̓Gg쐬ɎsfalseԂ܂B<br/>

        @param[out] pOut        Gg
        @param[in]  page        wy[W
        @param[in]  index       wCfbNX([0-17])
        @param[in]  color       쐬J[
        @param[in]  fill        쐬邤܂
        @param[in]  form        쐬`

        @return     trueŃGg쐬BfalseŃGg쐬sB
    */
    bool CreateEntry( VoiceEntry* pOut, VoicePage page, s32 index, VoiceColor color, VoiceFill fill, VoiceForm form );

    /*!
        @brief      w肳ꂽGg폜܂

                    wCfbNXɎwł͈͂[0-17]ɂȂ܂B<br/>
                    wy[WAwCfbNXɃf[^ꍇfalseԂ܂<br/>

        @param[in]  page        wy[W
        @param[in]  index       wCfbNX([0-17])

        @return     trueŃGg폜BfalseŃGg폜sB
    */
    bool DeleteEntry( VoicePage page, s32 index );

    /*!
        @brief      w肳ꂽGg̉f[^ǂݍ݂܂

                    wy[WSDJ[h̃y[Ŵݎwł܂B<br/>
                    wCfbNXɎwł͈͂[0-17]ɂȂ܂B<br/>
                    ndatãobt@VOICE_LIMIT_BYTESŒŊmۂ̂nĂ

        @param[out] readCount   ǂݎTCY
        @param[in]  page        wy[W
        @param[in]  index       wCfbNX([0-17])
        @param[in]  data        ǂݎf[^(m4ãf[^)
        @param[in]  dataSize    VOICE_LIMIT_BYTESŒ

        @retval     ResultSuccess               ǂݍݐ
        @retval     ResultMediaAccessError      fBAANZXG[
        @retval     ResultError                 ̑̕sȃG[
    */
    Result ReadVoice( s32* readCount, VoicePage page, s32 index, void* data, size_t dataSize = VOICE_LIMIT_BYTES );

    /*!
        @brief      w肳ꂽGg։f[^݂܂

                    w肳ꂽy[WACfbNXɁAdataɓnꂽm4af[^݂܂<br/>
                    wy[WSDJ[h̃y[Ŵݎwł܂B<br/>
                    wCfbNXɎwł͈͂[0-17]ɂȂ܂B<br/>

        @param[in]  page        wy[W
        @param[in]  index       wCfbNX([0-17])
        @param[in]  color       쐬J[
        @param[in]  fill        쐬邤܂
        @param[in]  form        쐬`
        @param[in]  data        쐬f[^(m4ãf[^)
        @param[in]  dataSize    쐬f[^TCY

	    @retval     ResultSuccess               ݐ
	    @retval     ResultNotEnoughSpace        eʕsG[
	    @retval     ResultWriteProtected        ݋֎~G[
	    @retval     ResultMediaAccessError      fBAANZXG[
	    @retval     ResultError                 ̑̕sȃG[
    */
    Result WriteVoice( VoicePage page, s32 index, VoiceColor color, VoiceFill fill, VoiceForm form, const void* data, size_t dataSize );

    /*!
        @brief      {ID擾

                    {ID̉32Bit16i8(I[NULL܂܂Ȃ)ƂĎ擾܂B

        @param[out] 擾ꂽ{ID
    */
    void GetBodyId( u8 bodyId[8] );
}


#endif /* SNDIO_API_H */
