/**-----------------------------------------------------------------------------

	@file		sndio_CachedReader.h
	@author		tetsu
	@par		[]
				LbVǂݍ݃NX(J)

				Copyright (c)2010 Nintendo All rights reserved.

----------------------------------------------------------------------------- */

#ifndef SNDIO_CACHED_READER_H
#define SNDIO_CACHED_READER_H


#include <nn/fs.h>


namespace sndio { namespace detail {


//! LbVǂݍ݃t@C(fR[_[Ŏgpp)
class CachedReader : public nn::fs::IInputStream
{
public:

	//! LbVftHg̃TCY(mۂobt@2{ɂȂ)
	static const size_t c_defaultSize = 4 * 1024;

	CachedReader();
	virtual ~CachedReader();

	//! t@CI[v
	bool Open( nn::fnd::IAllocator& allocator, const wchar_t* pathName,
		size_t cacheSize = c_defaultSize );

	//! t@CN[Y
	void Close();

	//! ǂݍ
	virtual nn::Result TryRead( s32* pOut, void* buffer, size_t size );
	virtual s32 Read( void* buffer, size_t size );

	//! V[N
	virtual nn::Result TrySeek( s64 position, nn::fs::PositionBase base );
	virtual void Seek( s64 position, nn::fs::PositionBase base );

	//! ݂̃V[Nʒu擾
	virtual nn::Result TryGetPosition( s64* pOut ) const;
	virtual s64 GetPosition() const;

	//! ݂̃V[Nʒuݒ
	virtual nn::Result TrySetPosition( s64 position );
	virtual void SetPosition(s64 position);

	//! t@CTCY擾
	virtual nn::Result TryGetSize( s64* pOut ) const;
	virtual s64 GetSize() const;

private:

	nn::fnd::IAllocator*	m_allocator;		//!< AP[^

	// t@C
	nn::fs::FileReader		m_reader;			//!< ǂݎt@C
	s32						m_seekPosition;		//!< V[Nʒu

	// LbV֘A
	u8*						m_cache;			//!< LbVobt@
	size_t					m_cacheSize;		//!< LbVĂe
	s32						m_cachePosition;	//!< LbVĂʒu
	s64						m_fileSize;			//!< t@CTCY
};


}}


#endif // SNDIO_CACHED_READER_H
