/**-----------------------------------------------------------------------------

	@file		sndio_CachedWriter.h
	@author		tetsu
	@par		[]
				݂ɓt@Co̓NX(J)

				Copyright (c)2010 Nintendo All rights reserved.

----------------------------------------------------------------------------- */

#ifndef SNDIO_CACHED_WRITER_H
#define SNDIO_CACHED_WRITER_H

#include <nn/fs.h>

namespace sndio { namespace detail {


class CachedWriter : public nn::fs::IOutputStream
{
public:

	CachedWriter( nn::fnd::IAllocator& allocator );
	virtual ~CachedWriter();

	//! t@CI[v
	nn::Result TryInitialize( const wchar_t* pathName );

	//! 
	virtual nn::Result TryWrite( s32* pOut, const void* buffer, size_t size, bool flush=true );
	virtual s32 Write( const void* buffer, size_t size, bool flush=true );

	//! t@CTCY̐ݒ
	virtual nn::Result TrySetSize(s64 size);
	virtual void SetSize(s64 size);

	//! V[N
	virtual nn::Result TrySeek( s64 position, nn::fs::PositionBase base );
	virtual void Seek( s64 position, nn::fs::PositionBase base );

	//! ݂̃V[Nʒu擾
	virtual nn::Result TryGetPosition( s64* pOut ) const;
	virtual s64 GetPosition() const;

	//! ݂̃V[Nʒuݒ
	virtual nn::Result TrySetPosition( s64 position );
	virtual void SetPosition(s64 position);

	//! t@CTCY擾
	virtual nn::Result TryGetSize( s64* pOut ) const;
	virtual s64 GetSize() const;

	//! ۂ̃t@Cɏo
	nn::Result FlushWrite();

private:

	nn::fnd::IAllocator&		m_allocator;		//!< AP[^
	u8*							m_buffer;			//!< ݗpobt@
	size_t						m_bufferSize;		//!< ݗpobt@TCY
	s64							m_seekPosition;		//!< ݃V[Nʒu
	size_t						m_writeSize;		//!< ܂TCY
	wchar_t						m_pathName[ nn::fs::MAX_FILE_PATH_LENGTH + 1 ];
};


}}


#endif // SNDIO_CACHED_WRITER_H
