#ifndef SNDIO_CONVERTER_H
#define SNDIO_CONVERTER_H


#include <wchar.h>
#include <nn/types.h>
#include <nn/fs.h>
#include "sndio_VoiceTypes.h"
#include "sndio_VoiceManager.h"


#define SNDIO_CONVERT_LENGTH 128


namespace sndio { namespace detail {

//! ϊɎg鎞ԕϊR[obN`
typedef void (*DateTimeCallback)( wchar_t* pOut, nn::fnd::DateTime& date );

//! ϊɎg郆[U[
void SetUserName( const wchar_t* userName );

//! ϊɎgAvP[V
void SetAppTitle( const wchar_t* appName );

//! ϊɎg鎞ԕϊR[obN
void SetDateTimeCallback( DateTimeCallback pCallback );


//! CTR̈̃f[^(m4a)TWL̈̃f[^(ADPCM)֕ϊ
bool ConvertToADPCM(
	VoiceManager& manager,
	nn::fnd::IAllocator& allocator,
	const VoiceData* voice,
	const TwlVoiceData* twlVoice );


//! TWL̈̃f[^(ADPCM)CTR̈̃f[^(m4a)֕ϊ
bool ConvertToM4A(
	VoiceManager& manager,
	nn::fnd::IAllocator& allocator,
	const TwlVoiceData* twlVoice,
	const VoiceData* voice );


}}


#endif // SNDIO_CONVERTER_H
