/**-----------------------------------------------------------------------------

	@file		sndio_Decoder.h
	@author		tetsu
	@par		[]
				fR[hsC^tF[XNX(J)

				Copyright (c)2010 Nintendo All rights reserved.

----------------------------------------------------------------------------- */

#ifndef SNDIO_DECODER_H
#define SNDIO_DECODER_H

#include <wchar.h>
#include <nn/types.h>
#include <nn/fs.h>
#include <nn/dbg.h>
#include "sndio_Result.h"
#include "sndio_VoiceExtendTag.h"


////////////////////////////////////////////////////////////////////////////////
// fR[_[`
////////////////////////////////////////////////////////////////////////////////

namespace sndio { namespace detail {


//! fR[_[C^tF[X
class IDecoder
{
public:

	//! 鎞Ԃ̍ő(~b)
	static const u32 c_totalTimeMax = 36000000;	// 10 * 60 * 60 * 1000

	virtual ~IDecoder() {};

	//! 
	virtual Result Initialize(
		nn::fnd::IAllocator* allocator,
		nn::fs::IInputStream* stream,
		ExtendTag* pExtTag ) = 0;

	//! j
	virtual void Finalize() = 0;

	//! Pt[̃Tv擾܂B
	virtual u32 GetFrameSamples() const = 0;

	//! Pt[̃obt@TCY(Byte)擾܂
	virtual u32 GetFrameBufferSize() const = 0;

	//! TvO[g擾܂B
	virtual s32 GetSamplingRate() const = 0;

	//! `l擾܂B
	virtual s32 GetChannelCount() const = 0;

	//! ĐԂ擾܂(msecP)
	virtual s32 GetTotalTime() const = 0;

	//! V[NԂ擾܂(msecP)
	virtual s32 GetSeekTime() const = 0;

	//! (msecP)ŃV[Nʒuݒ肵܂
	virtual s32 SetSeekTime( s32 seekTime ) = 0;

	//! V[N\
	virtual bool CanSeek() const = 0;

	//! tĐw
	virtual void SetReverse( bool reverse ) = 0;

	//! TEh̔g`f[^(PCM16)擾܂B
	virtual Result TryRead( s32* readCount, s16* pBufL, s16* pBufR, s32 samples ) = 0;

	//! ^Cg擾
	virtual const wchar_t* GetTitleName() const = 0;

	//! A[eBXg擾
	virtual const wchar_t* GetArtistName() const { return NULL; }

	//! Ao擾
	virtual const wchar_t* GetAlbumName() const { return NULL; }
};


/**-----------------------------------------------------------------------------

	@brief		TvO[g擾
	@param[in]	rateIdx			[gCfbNX
	@return		擾łTEh^CvԂ܂
	@par		[]
				[gCfbNXTvO[g擾

----------------------------------------------------------------------------- */
int GetSamplingRateIdx( int rateIdx );


/**-----------------------------------------------------------------------------

	@brief		mvhd(fBAi[){bNX쐬o

	@param[out]	dateTime		쐬
	@param[in]	mvhdBox			mvhd{bNX擪f[^(32Byte)
	@return		擾ɐtrue, 擾Ɏsfalse

----------------------------------------------------------------------------- */
bool M4ADemux_GetCreationTime( nn::fnd::DateTime& dateTime, const u8 mvhdBox[32] );


/**-----------------------------------------------------------------------------

	@brief		AACf[^TCY̌vZ(ADTSp)
	@param[in]	in				AACf[^obt@̃AhX(t[擪)
	@return		AACf[^TCY(Pt[)
	@par		[]
				AACf[^̃TCYoCgŕԂ܂<br>
				AACf[^ADTS`łȂꍇA0Ԃ܂

----------------------------------------------------------------------------- */
int calc_aac_size( const u8* in );


/**-----------------------------------------------------------------------------

	@brief		AACTvO[gCfbNX擾(ADTSp)
	@param[in]	in				AACf[^obt@̃AhX(t[擪)
	@return		AACTvO[gCfbNX
	@par		[]
				AACTvO[gCfbNX擾܂<br>
				AACf[^ADTS`łȂꍇA0Ԃ܂

----------------------------------------------------------------------------- */
int calc_aac_sampleidx( const u8* in );


/**-----------------------------------------------------------------------------

	@brief		AAC`l擾(ADTSp)
	@param[in]	in				AACf[^obt@̃AhX(t[擪)
	@return		AAC`l
	@par		[]
				AAC`l擾܂<br>
				AACf[^ADTS`łȂꍇA0Ԃ܂

----------------------------------------------------------------------------- */
int calc_aac_channel( const u8* in );



/**-----------------------------------------------------------------------------

	@brief		MP3f[^TCY̎Zo
	@param[in]	in				MP3f[^obt@̃AhX(t[擪)
	@return		MP3f[^TCY(Pt[)
	@par		[]
				MP3f[^̃TCYoCgŕԂ܂

----------------------------------------------------------------------------- */
int calc_mp3_size( const u8* in );


/**-----------------------------------------------------------------------------

	@brief		MP3TvO[g擾
	@param[in]	in				MP3f[^obt@̃AhX(t[擪)
	@return		MP3TvO[gCfbNX
	@par		[]
				MP3TvO[gCfbNXԂ܂

----------------------------------------------------------------------------- */
int calc_mp3_sampleidx( const u8* in );


/**-----------------------------------------------------------------------------

	@brief		MP3`l擾
	@param[in]	in				MP3f[^obt@̃AhX(t[擪)
	@return		MP3`l
	@par		[]
				MP3`l擾܂

----------------------------------------------------------------------------- */
int calc_mp3_channel( const u8* in );


/**-----------------------------------------------------------------------------

	@brief		MP3TChTCY擾
	@param[in]	in				MP3f[^obt@̃AhX(t[擪)
	@return		MP3TChTCY
	@par		[]
				MP3TChTCY擾擾܂

----------------------------------------------------------------------------- */
int calc_mp3_side( const u8* in );


/**-----------------------------------------------------------------------------

	@brief		MP3rbg[g擾
	@param[in]	in				MP3f[^obt@̃AhX(t[擪)
	@return		MP3TChTCY
	@par		[]
				MP3rbg[g擾܂

----------------------------------------------------------------------------- */
int calc_mp3_bitrate( const u8* in );


/**-----------------------------------------------------------------------------

	@brief		MP3̓t[T
	@param[in]	seekPoint		V[NJnʒu
	@param[in]	pStream			f[^Xg[
	@return		t[ItZbg(ꍇ u32(-1) )
	@par		[]
				MP3̓t[T܂

----------------------------------------------------------------------------- */
u32 calc_mp3_findsync( u32 seekPoint, nn::fs::IInputStream* stream);


/**-----------------------------------------------------------------------------

	@brief		ID3^OXLbv擾
	@param[in]	pStream			f[^Xg[
	@param[out]	pHeaderOfs		wb_ItZbg(Ȃ0)
	@param[out]	pFooterSize		tb^TCY(Ȃ0)
	@return		Xg[TCY
	@par		[]
				ID3^O͂Awb_TCYƃtb^TCY擾܂<br>
				ꂼꑶ݂Ȃꍇ0Ԃ܂

----------------------------------------------------------------------------- */
s32 id3_tag_skip( nn::fs::IInputStream* stream, u32* pHeaderOfs, u32* pFooterSize );


}}


#endif // SNDIO_DECODER_H
