/**-----------------------------------------------------------------------------

	@file		sndio_DecoderAACArm.h
	@author		tetsu
	@par		[]
				AACCPU(ARM11)ŃfR[hsNX(J)

				Copyright (c)2010 Nintendo All rights reserved.

----------------------------------------------------------------------------- */

#ifndef SNDIO_DECODER_AAC_ARM_H
#define SNDIO_DECODER_AAC_ARM_H


#include <wchar.h>
#include <nn/types.h>
#include <nn/fs.h>
#include <nn/dbg.h>
#include <tmc_aacdec.h>
#include "sndio_Decoder.h"


////////////////////////////////////////////////////////////////////////////////
// CPUfR[_[NX`
////////////////////////////////////////////////////////////////////////////////

namespace sndio { namespace detail {


//! CPUfR[_[NX
class DecoderAACArm : public IDecoder
{

public:

	//! AAĈPt[Tv
	static const u32 AAC_FRAME_SAMPLES = 1024;

	DecoderAACArm();
	virtual ~DecoderAACArm();

	//! 
	virtual Result Initialize(
		nn::fnd::IAllocator* allocator,
		nn::fs::IInputStream* stream,
		ExtendTag* pExtTag );

	//! j
	virtual void Finalize();

	//! Pt[̃Tv擾܂B
	virtual u32 GetFrameSamples() const;

	//! Pt[̃obt@TCY(Byte)擾܂
	virtual u32 GetFrameBufferSize() const;

	//! TvO[g擾܂B
	virtual s32 GetSamplingRate() const;

	//! `l擾܂B
	virtual s32 GetChannelCount() const;

	//! ĐԂ擾܂(msecP)
	virtual s32 GetTotalTime() const;

	//! V[NԂ擾܂(msecP)
	virtual s32 GetSeekTime() const;

	//! V[N\ǂ
	virtual bool CanSeek() const;

	//! tĐw
	virtual void SetReverse( bool reverse );

	//! (msecP)ŃV[Nʒuݒ肵܂
	virtual s32 SetSeekTime( s32 seekTime );

	//! TEh̔g`f[^(PCM16)擾܂B
	virtual Result TryRead( s32* readCount, s16* pBufL, s16* pBufR, s32 samples );

	//! ^Cg擾
	virtual const wchar_t* GetTitleName() const;

private:

	nn::fnd::IAllocator*	m_allocator;		//!< AP[^
	nn::fs::IInputStream*	m_stream;			//!< t@C
	s16*					m_buffer;			//!< Tvobt@
	s32						m_samplingRate;		//!< TvO[gCfbNX
	s32						m_channel;			//!< `l
	s32						m_totalTime;		//!< TEhŜ̎
	s32						m_seekTime;			//!< V[N
	u32						m_frameCount;		//!< t[
	void*					m_handle;			//!< demuxnh
	u8*						m_trak;				//!< TRAKf[^
	u32						m_trakSize;			//!< TRAKTCY
	s32*					m_heap;				//!< q[v
	TMC_AACDec*				m_aacdec;			//!< fR[_[
	TMC_AACDecInitParams	m_param;			//!< p[^
	wchar_t					m_titleName[ 128 ];	//!< ^Cg
	wchar_t					m_artistName[ 128 ];//!< A[eBXg
	wchar_t					m_albumName[ 128 ];	//!< Ao
};


}}


#endif // SNDIO_DECODER_AAC_ARM_H
