/**-----------------------------------------------------------------------------

	@file		sndio_MP3Seek.h
	@author		tetsu
	@par		[]
				MP3̃V[NsNX(J)

				Copyright (c)2010 Nintendo All rights reserved.

----------------------------------------------------------------------------- */

#ifndef SNDIO_MP3_SEEK_H
#define SNDIO_MP3_SEEK_H


////////////////////////////////////////////////////////////////////////////////
// MP3Seek`
////////////////////////////////////////////////////////////////////////////////

namespace sndio { namespace detail {


class MP3Seek
{
public:

	//! XINGtO
	enum
	{
		FLAG_IS_FRAMES = 	(1<<0),		// t[݂
		FLAG_IS_BYTES = 	(1<<1),		// Xg[TCY݂
		FLAG_IS_TOC = 		(1<<2),		// TOC񂪑݂
		FLAG_IS_VBR_SCALE = (1<<3)		// VBRi݂
	};

	MP3Seek();
	~MP3Seek();

	//! ĐԂ擾܂(msecP)
	s32 GetTotalTime() const;

	//! V[NԂ擾܂(msecP)
	s32 GetSeekTime() const;

	//! (msecP)Ńt@CV[Nʒu擾܂
	s32 SeekToTime( s32 seekTime );

	//! V[N\
	bool CanSeek() const;

	//! 
	bool Initialize( nn::fs::IInputStream* stream, u32 streamSize );

private:

	//! XINGœǂݍ
	bool ReadXING( nn::fs::IInputStream* stream );

	//! VBRIœǂݍ
	bool ReadVBRI( nn::fs::IInputStream* stream );

	//! t[Tv
	int GetSamplePerFrame() const
	{
		if (m_samplingRate< 32000)
			return 1152 / 2;

		return 1152;
	}

private:

	bool	m_existXing;			//!< XING
	bool	m_existVBRI;			//!< VBRI
	NN_PADDING2;

	int		m_bitrate;				//!< rbg[g(ŏ̃t[)
	int		m_samplingRate;			//!< TvO[g
	s32		m_totalTime;			//!< 

	u32		m_headerTag;			//!< wb_^O
	u32		m_headerFlags;			//!< tO
	u32		m_numberOfFrames;		//!< t[
	u32		m_totalStreamSize;		//!< Xg[TCY
	u16		m_tocSize;				//!< TOC e[uTCY
	u16		m_tocScale;				//!< TOCXP[
	u8		m_toc[ 65536 ];			//!< TOCGg
	u16		m_vbrQuality;			//!< VBRi(0ōi ` 100 Œi)
	NN_PADDING2;
};


}}


#endif // MP3_SEEK_H
