/**-----------------------------------------------------------------------------

	@file		sndio_Mount.h
	@author		tetsu
	@par		[]
				}Eg`

				Copyright (c)2010 Nintendo All rights reserved.

----------------------------------------------------------------------------- */

#ifndef SNDIO_MOUNT_H
#define SNDIO_MOUNT_H

#include <nn/types.h>
#include <nn/assert.h>
#include <nn/Result.h>


// #define SND_IO_EMULATE_CTR_NAND_ON_SD

// A[JCu`
#define SNDIO_SD_VIRTUAL_ARCHIVE_NAMEA	"$_sdmc:"
#define SNDIO_SD_ARCHIVE_NAMEA			"$sndsd:"
#define SNDIO_CTR_NAND_ARCHIVE_NAMEA	"$sndsh:"
#define SNDIO_TWL_NAND_ARCHIVE_NAMEA	"twls:"

#define SNDIO_SD_VIRTUAL_ARCHIVE_NAMEW	L"$_sdmc:"
#define SNDIO_SD_ARCHIVE_NAMEW			L"$sndsd:"
#define SNDIO_CTR_NAND_ARCHIVE_NAMEW	L"$sndsh:"
#define SNDIO_TWL_NAND_ARCHIVE_NAMEW	L"twls:"


namespace sndio { namespace detail {


/*!
	@brief		SDJ[hւ̃}Egs܂B

				sndionCugꍇɕKĂяoĂB<br/>

	@return		nn::ResultŌʂԂ܂(W[nn::fs)
*/
nn::Result MountSD();


/*!
	@brief		SDJ[h̃A}Egs܂B

	@return		nn::ResultŌʂԂ܂(W[nn::fs)
*/
nn::Result UnmountSD();


/*!
	@brief		CTR NAND̈̃}Egs܂B

				sndionCuCTR NAND̈ꍇɕKĂяoĂB<br/>

	@return		nn::ResultŌʂԂ܂(W[nn::fs)
*/
nn::Result MountCtrNand();


/*!
	@brief		CTR NAND̈A}Eg܂B

	@return		nn::ResultŌʂԂ܂(W[nn::fs)
*/
nn::Result UnmountCtrNand();


/*!
	@brief		TWL NAND̈}Egs܂B

				sndionCuTWL NAND̈ꍇɕKĂяoĂB<br/>

	@return		nn::ResultŌʂԂ܂(W[nn::fs)
*/
nn::Result MountTwlNand();


/*!
	@brief		TWL NAND̈A}Eg܂B

	@return		nn::ResultŌʂԂ܂(W[nn::fs)
*/
nn::Result UnmountTwlNand();


/*!
	@brief		ۂɎgpXϊ܂

	@return		ϊꂽpXւ̃|C^
*/
const wchar_t* ToReal( wchar_t* path );


/*!
	@brief		zIɎgpXϊ܂

	@return		ϊꂽpXւ̃|C^
*/
const wchar_t* ToVirtual( wchar_t* path );


/*!
	@brief		zIȃpXǂԂ܂

	@return		true zpX
*/
bool IsVirtual( const wchar_t* path );


/*!
	@brief		A[JCu^Cv
*/
typedef enum
{
	ARCHIVE_TYPE_SD,				//!< SDJ[ḧ
	ARCHIVE_TYPE_CTR_NAND,			//!< CTR{̕ۑ̈
	ARCHIVE_TYPE_TWL_NAND			//!< TWLTEḧ
} ArchiveType;


const std::size_t SD_ARCHIVE_PREFIX_SIZE = sizeof(SNDIO_SD_VIRTUAL_ARCHIVE_NAMEW) - sizeof(wchar_t);


/*!
	@brief		A[JCu̎擾(char_t)

	@return		擾A[JCu
*/
inline const char* GetArchiveNameA( ArchiveType archiveType )
{
	switch (archiveType)
	{
	case ARCHIVE_TYPE_SD:		return SNDIO_SD_ARCHIVE_NAMEA;
	case ARCHIVE_TYPE_CTR_NAND:	return SNDIO_CTR_NAND_ARCHIVE_NAMEA;
	case ARCHIVE_TYPE_TWL_NAND:	return SNDIO_TWL_NAND_ARCHIVE_NAMEA;
	}

	NN_TASSERT_( false );
	return NULL;
}


/*!
	@brief		A[JCu̎擾(wchar_t)

	@return		擾A[JCu
*/
inline const wchar_t* GetArchiveNameW( ArchiveType archiveType )
{
	switch (archiveType)
	{
	case ARCHIVE_TYPE_SD:		return SNDIO_SD_ARCHIVE_NAMEW;
	case ARCHIVE_TYPE_CTR_NAND:	return SNDIO_CTR_NAND_ARCHIVE_NAMEW;
	case ARCHIVE_TYPE_TWL_NAND:	return SNDIO_TWL_NAND_ARCHIVE_NAMEW;
	}

	NN_TASSERT_( false );
	return NULL;
}


}}


#endif /* SNDIO_MOUNT_H */
