/*---------------------------------------------------------------------------*
  Project:  sndio
  File:     sndio_Result.h

  Copyright (C)2010 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

 *---------------------------------------------------------------------------*/

#ifndef SNDIO_RESULT_H_
#define SNDIO_RESULT_H_

#include <nn/types.h>

namespace sndio {


/*!

    @brief ʗ񋓌^

  @ref ResultError<br/>
    JeS̈ʃG[łB<br/>
    KRIȃG[̏ꍇȂǂɗpĂ܂B<br/>
    ̃G[Ԃꂽꍇ́Aǂʂ̂Ƃł̓IȃG[Ԃ
    邱Ƃ܂B

  @ref ResultFileNotFound<br/>
    w肵t@CȂꍇȂǂɔG[łB<br/>
    bZ[WoȂǂăvOs悤ɍ쐬Kv܂B<br/>

  @ref ResultMediaNotFound<br/>
    w肵fBA(SD)ȂꍇȂǂɔG[łB<br/>
    bZ[WoȂǂăvOs悤ɍ쐬Kv܂B<br/>

  @ref ResultMediaInvalid<br/>
    w肵fBA(SD)sȏꍇɔG[łB<br/>
    bZ[WoȂǂăvOs悤ɍ쐬Kv܂B<br/>

  @ref ResultAlreadyExists<br/>
    łɃt@C݂ꍇȂǂɔG[łB<br/>
    bZ[WoȂǂăvOs悤ɍ쐬Kv܂B<br/>

  @ref ResultNotEnoughSpace<br/>
    ۑ̃fBAɋ󂫗eʂȂꍇȂǂɔG[łB<br/>
    bZ[WoȂǂăvOs悤ɍ쐬Kv܂B<br/>

  @ref ResultArchiveInvalidated<br/>
    A[JCu̗Rɂ薳ɂȂꍇȂǂɔG[łB<br/>
    ꂪN錴̓}EgA[JCuSDJ[hȂǂɂĖ
    ȂꍇłB<br/>
    vOōă}EgsKv܂B<br/>

  @ref ResultOperationDenied<br/>
    t@CɊւ鏈sꍇɔG[łB<br/>
    Ώۃt@C̃ANZX͋ۂĂԂlA
    bZ[WoȂǂăvOs悤ɍ쐬Kv܂B<br/>

  @ref ResultWriteProtected<br/>
    CgveNgĂSDJ[hɑ΂ďݏꍇɋN
    G[łB<br/>
    ʏ̗płʂɌG[̂߁AĂȂ悤ɃvO
    Kv܂B<br/>

  @ref ResultMediaAccessError<br/>
    A[JCu̗Rɂ薳ɂȂꍇȂǂɔG[łB<br/>
    ꂪN錴̓}EgA[JCuSDJ[hȂǂɂ
    ɂȂꍇłB<br/>
    vOōă}EgsKv܂B<br/>

  @ref ResultBadFormat<br/>
    ̃G[́AΏۂ̃A[JCu⃁fBÃtH[}bgs
    Ԃł邱Ƃ܂B<br/>
    ̃G[t@C쎞ɔƂ́Ãt@C폜
    蒼悤ɂĂB<br/>

  @ref ResultOutOfResource<br/>
    œnAP[^̊mۏɎsꍇɔG[łB<br/>
    ̃G[͐iŔȂ悤ɂĂB<br/>

  @ref ResultNotInitialize<br/>
    InitializeĂяoꍇȂǂɔG[łB<br/>
    Ăяot[ȂǂȂ悤ɂĂB<br/>

  @ref ResultNotFinalize<br/>
    FinalizeĂяoĂȂꍇInitializeĂяoꍇȂǂɔG[łB<br/>
    Ăяot[ȂǂȂ悤ɂĂB<br/>

  @ref ResultInvalidFile<br/>
    ĐłȂt@Cw肳ꂽꍇɔG[łB<br/>
    yt@C(m4a,3gp,mp4,mp3)łĂgĂA<br/>
    T|[głȂԂTvO[głꍇ\܂B<br/>
    ĂȂ悤ɃvOKv܂B<br/>

  @ref ResultInvalidParameter<br/>
    nꂽɖ肪ꍇɔG[łB
    {Iɂ̓Cu̎g̖̃G[̂߁AȂǂȂĂ
    B

  @ref ResultInvalidDecoder<br/>
    DEMUXA܂̓fR[_̃G[ƂɌĂяoG[łB
    bZ[WoȂǂăvOs悤ɍ쐬Kv܂B

  @ref ResultInvalidEncoder<br/>
    MUXA܂̓GR[_̃G[ƂɌĂяoG[łB
    ̃G[Ƃ́At@C̏ԂĂ\̂
    t@Ĉ폜邩蒼悤ɂĂB

*/
typedef enum
{
    ResultSuccess               = 0,        //!< 

    ResultError                 = -1,       //!< sȃG[
    ResultFileNotFound          = -2,       //!< t@CEA[JCu܂B
    ResultMediaNotFound         = -3,       //!< fBAȂA͔Fł܂B
    ResultMediaInvalid          = -4,       //!< sȃfBAłB
    ResultAlreadyExists         = -5,       //!< t@CEA[JCu͊ɑ݂Ă܂B
    ResultNotEnoughSpace        = -6,       //!< 󂫗eʂ܂B
    ResultArchiveInvalidated    = -7,       //!< A[JCuɂȂ܂B
    ResultOperationDenied       = -8,       //!< t@C삪ۂ܂B
    ResultWriteProtected        = -9,       //!< ݂֎~ɂĂ܂B
    ResultMediaAccessError      = -10,      //!< fBAւ̃ANZXɃG[܂B
    ResultNotFormatted          = -11,      //!< tH[}bgĂ܂B
    ResultBadFormat             = -12,      //!< sȃtH[}bgłB

    ResultOutOfResource         = -100,     //!< \[XsłB
    ResultNotInitialize         = -101,     //!< InitializeĂяoĂ܂B
    ResultNotFinalize           = -102,     //!< FinalizeĂяoĂ܂B
    ResultInvalidFile           = -103,     //!< T|[gĂȂt@CłB
    ResultInvalidParameter      = -104,     //!< sł
    ResultInvalidDecoder        = -105,     //!< fR[_̃G[܂B
    ResultInvalidEncoder        = -106      //!< GR[_̃G[܂B

} Result;


}


#endif /* SNDIO_RESULT_H_ */
