/**-----------------------------------------------------------------------------

	@file		sndio_UftConv.h
	@author		tetsu
	@par		[]
				ϊ֘A

				Copyright (c)2011 Nintendo All rights reserved.

----------------------------------------------------------------------------- */

#ifndef SNDIO_UTFCONV_H
#define SNDIO_UTFCONV_H


namespace sndio { namespace detail { namespace utf {

typedef enum 
{
    ENC_CODE_UTF8,      // UTF8
    ENC_CODE_UTF16BE,   // UTF16(BigEndian)
    ENC_CODE_UTF16LE,   // UTF16(LittleEndian)
    ENC_CODE_MAX
} ENCCode;

typedef enum 
{
    ENC_ERR_NO_BUF_LEFT    = -1,    // o͗p̃obt@܂
    ENC_ERR_INVALID_FORMAT = -2,    // ̓f[^ɕR[hƂĕsȉӏ܂B
    ENC_ERR_NOT_LOADED     = -3     // ͂r[ȈʒuŏIĂ܂B
} ENCErr;


/*!
	@brief		̒擾
	@param[in]	useSD       
	@return		
*/
int GetStringLength( const char* str );
int CopyLStringZeroFill(char *destp, const char *srcp, int n);


/*---------------------------------------------------------------------------*
  Name:         ENC_ConvUTF

  Description:  R[h̃Ro[gȂ܂B
                I[L͕t܂B
                
                o͗p̃obt@dstNULLw肵ꍇɂ́A
                o̓TCY̌vẐ݂Ȃ܂B

  Arguments:    dst        o͐obt@
                dst_len    o͐obt@̃obt@TCY
                dst_encode o̓GR[h
                src        ̓obt@
                src_len    ̓obt@̃obt@TCY
                src_encode ̓GR[h

  Returns:      o͂oCgԂ܂B
                sꍇɂ́AG[R[hԂ܂B
 *---------------------------------------------------------------------------*/
s32 ENC_ConvUTF(u8 *dst, s32 dst_len, ENCCode dst_encode, const u8 *src, s32 src_len, ENCCode src_encode);


/*---------------------------------------------------------------------------*
  Name:         ENC_SetUnicodeBOM

  Description:  oCgI[_[}[No͂܂B

  Arguments:    dst        o͐obt@
                dst_len    o͐obt@̃obt@TCY
                dst_encode o̓GR[h

  Returns:      o͂oCgԂ܂B
                sꍇɂ́AG[R[hԂ܂B
 *---------------------------------------------------------------------------*/
s32 ENC_SetUnicodeBOM(u8 *dst, s32 dst_len, ENCCode dst_encode);


}}}


#endif // SNDIO_UTFCONV_H
