/**-----------------------------------------------------------------------------

	@file		sndio_VoiceExtendTag.h
	@author		tetsu
	@par		[]
				g^O`

				Copyright (c)2010 Nintendo All rights reserved.

----------------------------------------------------------------------------- */

#ifndef SNDIO_VOICE_EXTEND_TAG_H
#define SNDIO_VOICE_EXTEND_TAG_H

#include <nn/types.h>


#if ( NN_ENDIAN == NN_ENDIAN_VALUE_LITTLE )
#define VOICE_MAKE_SIGWORD(a, b, c, d)							\
	static_cast<u32>(											\
	(static_cast<u8>(a) <<  0) | (static_cast<u8>(b) <<  8)		\
	| (static_cast<u8>(c) << 16) | (static_cast<u8>(d) << 24)	\
	)
#else
#define VOICE_MAKE_SIGWORD(a, b, c, d)							\
	static_cast<u32>(											\
	(static_cast<u8>(a) << 24) | (static_cast<u8>(b) << 16)		\
	| (static_cast<u8>(c) <<  8) | (static_cast<u8>(d) <<  0)	\
	)
#endif

namespace sndio {


/*!
	@brief		^OR[h
*/
static const u32 TAG_CODE = VOICE_MAKE_SIGWORD( 'c', 'o', 'd', 'e' );

/*!
	@brief		^O\tgEFA
*/
static const u32 TAG_SFTW = VOICE_MAKE_SIGWORD( 's', 'f', 't', 'w' );

/*!
	@brief		^{ID
*/
static const u32 TAG_RCID = VOICE_MAKE_SIGWORD( 'r', 'c', 'i', 'd' );

/*!
	@brief		ҏW{ID
*/
static const u32 TAG_EDID = VOICE_MAKE_SIGWORD( 'e', 'd', 'i', 'd' );

/*!
	@brief		p[~bV
*/
static const u32 TAG_PRMT = VOICE_MAKE_SIGWORD( 'p', 'r', 'm', 't' );


/*!
	@brief		Abv[h
*/
static const char PRMT_UPLOAD[]				= "upload";

/*!
	@brief		Abv[h\
*/
static const char PRMT_EDIT_DISTRIBUTE[]	= "editDistribute";

/*!
	@brief		zz\
*/
static const char PRMT_FIRST_DISTRIBUTE[]	= "firstDistribute";

/*!
	@brief		񎟔zz\
*/
static const char PRMT_SECOND_DISTRIBUTE[]	= "secondDistribute";


/*!
	@brief		g^O
*/
struct ExtendTag
{
	u8 code[5];					//!< '3DS1'
	u8 sftw[6];					//!< ۑ\tgEFAID
	u8 rcid[9];					//!< ^{ID
	u8 edid[9];					//!< CTRAvŕҏW{ID
	NN_PADDING3;

	u8 permitUpload;			//!< 0: 1:C^[lbgAbv[h
	u8 permitEditDistribute;	//!< 0: 1:zz
	u8 permitFirstDistribute;	//!< 0:s 1:
	u8 permitSecondDistribute;	//!< 0:񎟔zzs 1:񎟔zz
};


}


#endif // SNDIO_VOICE_EXTEND_TAG_H
